

// Don't Change this.This is Function.
#define GetShadow(a,b,c,d) mix(a, b, max(c,max(d,-d)))
#define GetLight(a,b,c) mix(a,b,max(c,-c))

// You can change this.Happy Coding ^_^

#define exposure 1.5 // Exposure Value.More big,More bright ( default is 1.5 ) [ 1.25, 1.5, 1.75 ]

#define saturation 1.5 // Saturation Value.More big,More saturated ( default is 1.5 ) [ 1.25, 1.5, 1.75 ]

#define CausticIntensity 4.0 // Caustic intensity.More big,More bright the Caustic ( default is 4.0 ) [ 4.0, 4.5, 5.0 ]

vec3 HDR ( vec3 indiff ){
    
    indiff = mix(indiff * .5, indiff * 1.5, indiff);
    
    indiff = clamp(indiff, vec3(.0), vec3(1.));
    return indiff;
}

vec3 GetGrayscale( vec3 diff, float set ){
    float grayscale = dot(diff, vec3(.2126, .7156, .0722));
    
    return mix(diff, vec3(grayscale), set);
}

vec3 curve(vec3 x) {
    
    vec3 A = vec3(.22);
    vec3 B = vec3(.3);
    vec3 C = vec3(.3);
    vec3 D = vec3(.708);
    vec3 E = vec3(.02);
    vec3 F = vec3(.5);
    x *= 2.;
    
    return clamp(((x * (A * x + C * B) + D * E) / (x * (A * x + B) + D * F)) - E / F,vec3(.0),vec3(1.)); 
} 

vec3 Contrast( vec3 color, float contrast ){
    
	float colorLength = length(color);
	vec3 nColor = color / colorLength;
	colorLength = pow(colorLength, contrast);
	return nColor * colorLength;
}

vec3 tone(vec3 clr) {
    
    clr = pow(clr, vec3(2.2));
    clr = clr / ( 1. + clr);
    
    vec3 Whitescale = vec3(1.) / curve(vec3(2.));
    clr *= vec3(exposure);
    
    float Luma = dot(clr.rgb, vec3(.2125, .7154, .0721));
    vec3 Chroma = clr - Luma;
    
    clr = ( Chroma * vec3(saturation)) + Luma;
    clr = pow(curve(clr), vec3(1./2.2));
    
    return clr;
}

void GetAo( inout vec3 indiff, in vec4 inclr){
    
    if(inclr.g*2. > inclr.r + inclr.b){
        #if defined(ALPHA_TEST) && !defined(BLEND)
        indiff *= inclr.rgb;
        #else
        indiff *= normalize(inclr.rgb*.9);
        #endif
    }else{
        indiff *= sqrt(inclr.rgb*1.3);
    }
    
}
